
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <termios.h>
#include <fcntl.h>

static int _Setup(char *szStr)
{
	int s32UartFd = open(szStr, O_RDWR | O_NOCTTY | O_NDELAY);
	if (s32UartFd == -1)
	{
		return s32UartFd;
	}
	
	struct termios options;
	tcgetattr(s32UartFd, &options);
	options.c_cflag |= CLOCAL | CREAD;
	cfmakeraw(&options);
	
	//ò
	cfsetospeed(&options, B9600);
	cfsetispeed(&options, B9600);

	//ճ
	options.c_cflag &= ~CSIZE;
	options.c_cflag |= CS8;
	options.c_cflag &= ~PARENB;
	options.c_iflag &= ~INPCK;
	options.c_cflag &= ~CSTOPB;
 	options.c_cc[VTIME] = 0;
	options.c_cc[VMIN] = 0;
	tcflush(s32UartFd, TCIOFLUSH);
  	tcsetattr(s32UartFd, TCSANOW, &options);

  	return s32UartFd;
}

int main(int argc, char** argv)
{
	int s32UartFd = -1;

	s32UartFd = _Setup("/dev/ttyACM0");
	if(s32UartFd == -1)
	{
		printf("򿪴ʧ!\n");
		goto label_EXIT;
	}

	printf("򿪴ڳɹ!\n");

	char szBuffer[1024];
	int s32BufferSize;

	s32BufferSize = 0;
	while(1)
	{
		int dwSize;
		dwSize = read(s32UartFd, szBuffer + s32BufferSize, 1);//ÿֻһֽ
		if (dwSize == -1)
		{
			printf("readʧ\n");
			goto label_EXIT;
		}

		if (dwSize == 1) //յһֽڣʱʱ䵽ҲλãdwSizeΪ0
		{
			szBuffer[s32BufferSize + 1] = 0;
			if(szBuffer[s32BufferSize] == 0x0d) //յ׺ַ϶һνս
			{
				printf("szBuffer %s\n", szBuffer);
				s32BufferSize = 0;
			}
			else
			{
				s32BufferSize ++;
				if (s32BufferSize >= sizeof(szBuffer) - 1)
				{
					printf("̫С\n");
					goto label_EXIT;
				}
			}
		}
	}

	close(s32UartFd);
	s32UartFd = -1;

label_EXIT:
	if(s32UartFd != -1)
	{
		close(s32UartFd);
		s32UartFd = -1;
	}
	return 0;
}

